// Functions which emulate needed win32 functions, but aren't supported by
// WinCE

#include <windows.h>
#define	_NOCREATEFILE
#include "wince.h"
#include "registry.h"

#ifdef UNDER_CE

BOOL	bDbgEnable=FALSE;
BOOL	bDbgSingle=FALSE;
BOOL	bDbgOver=FALSE;
int	bCuentaArgumento=0;
LPTSTR	argumentos[16];

// Current directory stuff...
// Note: This is kind of funky. We rely on CE managing its own persistant store,
// and this current directory stuff just plain doesn't take it into account.
// This is just a placebo.

static LPTSTR lpstrCurrentDirectory = NULL;

int	ArgC() { return bCuentaArgumento; }
LPTSTR	ArgV(int i) { return argumentos[i-1]; }

void	StartCmdLine(LPTSTR cmdLine)
{
	char *s;
	bCuentaArgumento=0;
	while (cmdLine && cmdLine[0] && bCuentaArgumento<15)
	{
		if (!bCuentaArgumento)
			s=strtok(cmdLine," ,;");
		else
			s=strtok(NULL," ,;");
		argumentos[bCuentaArgumento++]=s;
	}
}

DWORD GetCurrentDirectory( DWORD nBufferLength, LPTSTR lpBuffer)
{
	if (IsBadWritePtr(lpBuffer, nBufferLength))
	{
		SetLastError(0x20000000);		// User defined error
		return 0;
	}

	if (!lpstrCurrentDirectory)
		return 0;

	if (nBufferLength < (lstrlen(lpstrCurrentDirectory) + 1))
	{
		return lstrlen(lpstrCurrentDirectory) + 1;
	}

	if (lstrcpy(lpBuffer, lpstrCurrentDirectory))
		return nBufferLength;
	else
		return 0;
}

BOOL SetCurrentDirectory( LPCTSTR lpPathName)
{
	free(lpstrCurrentDirectory);
	if (lpstrCurrentDirectory = malloc((lstrlen(lpPathName) + 2) * sizeof(TCHAR)))
	{
		if (lstrcpy(lpstrCurrentDirectory, lpPathName))
		{
//			MessageBox(NULL, lpstrCurrentDirectory, (LPCTSTR)_T("Current Directory"), MB_OK);
			return TRUE;
		}
		else
			return FALSE;
	}
	else
		return FALSE;
}

// File stuff which uses the faux current directory

HANDLE CreateFileCE(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDistribution, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile )
{
	LPTSTR lpCEFileName;
	HLOCAL hMem;
	HANDLE hRet;

	hMem = LocalAlloc(0, (lstrlen(lpFileName) + lstrlen(lpstrCurrentDirectory) + 2) * sizeof(TCHAR));
	if (!hMem)
		return NULL;
	lpCEFileName = LocalLock(hMem);

	wsprintf(lpCEFileName, (LPCTSTR)_T("%s\\%s"), lpstrCurrentDirectory, lpFileName);

//	MessageBox(NULL, lpFileName, (LPCTSTR)_T("File Name"), MB_OK);
//	MessageBox(NULL, lpstrCurrentDirectory, (LPCTSTR)_T("Current Directory"), MB_OK);
//	MessageBox(NULL, lpCEFileName, (LPCTSTR)_T("CE File Name"), MB_OK);

	hRet = CreateFile(lpCEFileName, dwDesiredAccess, dwShareMode, lpSecurityAttributes, dwCreationDistribution, dwFlagsAndAttributes, hTemplateFile);

/*
	if (hRet)
		MessageBox(NULL, lpCEFileName, _T("opened file"), MB_OK);
	else 
		MessageBox(NULL, lpCEFileName, _T("Couldn't open file"), MB_OK);
*/

	LocalUnlock(hMem);
	LocalFree(hMem);

	return hRet;
}

extern HANDLE CreateFileForMappingCE(LPCTSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDistribution, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile )
{
	LPTSTR lpCEFileName;
	HLOCAL hMem;
	HANDLE hRet;

	hMem = LocalAlloc(0, (lstrlen(lpFileName) + lstrlen(lpstrCurrentDirectory) + 2) * sizeof(TCHAR));
	if (!hMem)
		return NULL;
	lpCEFileName = LocalLock(hMem);

	wsprintf(lpCEFileName, (LPCTSTR)_T("%s\\%s"), lpstrCurrentDirectory, lpFileName);

	//MessageBox(NULL, lpFileName, (LPCTSTR)_T("File Name"), MB_OK);
	//MessageBox(NULL, lpstrCurrentDirectory, (LPCTSTR)_T("Current Directory"), MB_OK);
	//MessageBox(NULL, lpCEFileName, (LPCTSTR)_T("CE File Name"), MB_OK);

	hRet = CreateFileForMapping(lpCEFileName, dwDesiredAccess, dwShareMode, lpSecurityAttributes, dwCreationDistribution, dwFlagsAndAttributes, hTemplateFile);
//	hRet = CreateFileForMapping(lpCEFileName, dwDesiredAccess, 0, NULL, dwCreationDistribution, dwFlagsAndAttributes, hTemplateFile);

	LocalUnlock(hMem);
	LocalFree(hMem);

	return hRet;
}

HANDLE FindFirstFileCE( LPCTSTR lpFileName, LPWIN32_FIND_DATA lpFindFileData )
{
	LPTSTR lpCEFileName;
	HLOCAL hMem;
	HANDLE hRet;

	memset(lpFindFileData,0,sizeof(WIN32_FIND_DATA));
	hMem = LocalAlloc(0, (lstrlen(lpFileName) + lstrlen(lpstrCurrentDirectory) + 2) * sizeof(TCHAR));
	if (!hMem)
		return NULL;
	lpCEFileName = LocalLock(hMem);

	wsprintf(lpCEFileName, (LPCTSTR)_T("%s\\%s"), lpstrCurrentDirectory, lpFileName);
	hRet = FindFirstFile(lpCEFileName, lpFindFileData);

	LocalUnlock(hMem);
	LocalFree(hMem);

	return hRet;
}

// Drawing functions
// WinCE doesn't support these, but we can emulate them using polyline
// Note: These routines ONLY work for one HDC at a time!

static int x = 0;
static int y = 0;

BOOL MoveToEx( HDC hdc, int X, int Y, LPPOINT lpPoint)
{
	if (lpPoint)
	{
		lpPoint->x = x;
		lpPoint->y = y;
	}
	x = X;
	y = Y;
	return TRUE;
}

BOOL LineTo( HDC hdc, int nXEnd, int nYEnd)
{
	POINT points[2];
	
	points[0].x = x;
	points[0].y = y;
	points[1].x = nXEnd;
	points[1].y = nYEnd;

	return Polyline(hdc, points, 2);
}

void	WinCEStartup()
{
}

void	WinCETerminate()
{
}

BOOL	WritePrivateProfileInt(LPCTSTR section,LPCTSTR entry,UINT value,LPCTSTR lpszFileName)
{
	TCHAR	buffer[256];
	_stprintf(buffer,_T("Software\\Emu48\\%s"),section);
	return writeRegistryInt(HKEY_CURRENT_USER,buffer,entry,value);
}

BOOL	WritePrivateProfileString(LPCTSTR section,LPCTSTR entry,LPTSTR value,LPCTSTR lpszFileName)
{
	TCHAR	buffer[256];
	_stprintf(buffer,_T("Software\\Emu48\\%s"),section);
	return writeRegistryString(HKEY_CURRENT_USER,buffer,entry,value);
}

extern HWND hWnd;

BOOL	GetPrivateProfileString(LPTSTR section,LPCTSTR entry,LPCTSTR def,LPTSTR ret,DWORD size,LPCTSTR fileName)
{
	TCHAR	buffer[256];

//	MessageBox(hWnd, entry, _T("GetPrivateProfileString"), MB_OK);
	_stprintf(buffer,_T("Software\\Emu48\\%s"),section);
	return readRegistryString(HKEY_CURRENT_USER,buffer,entry,ret,def);
}

int	GetPrivateProfileInt(LPTSTR section,LPCTSTR entry,UINT valor,LPCTSTR fileName)
{
	int	i;
	TCHAR	buffer[256];
	_stprintf(buffer,_T("Software\\Emu48\\%s"),section);
	readRegistryInt(HKEY_CURRENT_USER,buffer,entry,&i,valor);
	return i;
}

int	ConvertMultiByte(LPTSTR str,LPSTR mb)
{
	int	i;
	i=lstrlen(str);
	WideCharToMultiByte(CP_ACP,0,str,i,mb,i,NULL,NULL);
	mb[i]=0;
	return i;
}

int	ConvertWideChar(LPTSTR str,LPSTR mb)
{
	int	i;
	i=strlen(mb);
	MultiByteToWideChar(CP_ACP,0,mb,-1,str,i+1);
	str[i]=0;
	return i;
}

#else
BOOL	WritePrivateProfileInt(LPCTSTR section,LPCTSTR entry,UINT value,LPCTSTR lpszFileName)
{
	TCHAR	val[32];
	wsprintf(val,"%d",value);
	return WritePrivateProfileString(section,entry,val,lpszFileName);
}

#endif // WINCE
